<?php

namespace App\Repositories;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\QueryException;
use Prettus\Repository\Presenter\ModelFractalPresenter;


abstract class BaseRepository extends \Prettus\Repository\Eloquent\BaseRepository
{

    /**
     * Configure the Model
     *
     * @return string
     */
    abstract public function model();

    /**
     * Make Model instance
     *
     * @throws \Exception
     *
     * @return Model
     */
    public function makeModel()
    {
        $model = $this->app->make($this->model());

        if (!$model instanceof Model) {
            throw new \Exception("Class {$this->model()} must be an instance of Illuminate\\Database\\Eloquent\\Model");
        }

        return $this->model = $model;
    }

    public function find($id, $columns = ['*'])
    {
        try{
            return parent::find($id, $columns); // TODO: Change the autogenerated stub
        }catch (QueryException | \Exception $e){
            return null;
        }
    }

    public function first($columns = ['*'])
    {
        return parent::first($columns); // TODO: Change the autogenerated stub
    }


    /*public function presenter()
    {
        return ModelFractalPresenter::class;
    }*/
}
